MODULE_NAME='PLENA PLM-8M8' (DEV VD_MIXER,	// VIRTUAL DEVICE OF MIXER 
			     DEV VD_COMMS, 	// VIRTUAL DEVICE OF CENTRAL COMMS
			     CHAR MIXER_ADDR[],	// AMP ADDRESS
			     INTEGER MIXER_NO)  // AMP NUMBER
(***********************************************************)
(* System Type : NetLinx                                   *)
(***********************************************************)
(*                MIXER INTERFACE MODULE FOR               *) 
(*         BOSCH PLENA PLM-8M8 DSP MATRIX MIXER            *)
(*                                                         *)
(*      	BOSCH COMMUNICATIONS SYSTEMS               *)
(*    		    25 HUNTINGWOOD DRIVE                   *)
(*    		  HUNTINGWOOD NSW AUSTRALIA                *)
(*                                                         *)
(*	            VERSION 1.0 FEB 2014                   *)
(***********************************************************)
(***********************************************************)
(*          DEVICE NUMBER DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_DEVICE

(***********************************************************)
(*               CONSTANT DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_CONSTANT

(* SYSTEM *)
NOS_LEVELS			= 4
MAX_AMPS			= 10
MAX_ENTRIES			= 10
MAX_ENTRY_SIZE			= 128
QUEUE_SIZE			= 100

(* AMPLIFIER *)
TX_PORT				= 12128		// TRASMISSION UDP PORT
RX_PORT				= 12129		// RECEPTION UDP PORT

MIXER_ID			= $5E40
AMP_ID				= $5E41

MASTER_ID			= $0001
SLAVE_ID			= $0100

dsHEADER			= 1
dsCMD				= 2
dsDATA				= 3

lsOFFLINE			= 0
lsLOOKING			= 1
lsFOUND				= 2

(* GLOBAL OBJECTS *)
GOBJ_FORCE_STANDBY		= 47
GOBJ_GLOBAL_MUTE_ALLOWED	= 50
GOBJ_FORCE_GLOBAL_MUTE		= 51

(* PRESET OBJECTS *)
POBJ_Z1_CB_ML1_LEVEL		= 81 	// Zone 1 Mic/Line 1 Mix Level
POBJ_Z1_CB_ML2_LEVEL		= 82 	// Zone 1 Mic/Line 2 Mix Level
POBJ_Z1_CB_ML3_LEVEL		= 83 	// Zone 1 Mic/Line 3 Mix Level
POBJ_Z1_CB_ML4_LEVEL		= 84 	// Zone 1 Mic/Line 4 Mix Level
POBJ_Z1_CB_BGM_MUTEX		= 85 	// Zone 1 BGM Select & Level
POBJ_Z1_CB_MASTER_LEVEL		= 86	// Zone 1 Master Mix Level
POBJ_Z1_CB_PAGING_LEVEL		= 87	// Zone 1 Paging Mix Level

POBJ_Z2_CB_ML1_LEVEL		= 104 	// Zone 2 Mic/Line 1 Mix Level
POBJ_Z2_CB_ML2_LEVEL		= 105	// Zone 2 Mic/Line 2 Mix Level
POBJ_Z2_CB_ML3_LEVEL		= 106	// Zone 2 Mic/Line 3 Mix Level
POBJ_Z2_CB_ML4_LEVEL		= 107	// Zone 2 Mic/Line 4 Mix Level
POBJ_Z2_CB_BGM_MUTEX		= 108	// Zone 2 BGM Select & Level
POBJ_Z2_CB_MASTER_LEVEL		= 109	// Zone 2 Master Mix Level
POBJ_Z2_CB_PAGING_LEVEL		= 110	// Zone 2 Paging Mix Level

POBJ_Z3_CB_ML1_LEVEL		= 127 	// Zone 3 Mic/Line 1 Mix Level
POBJ_Z3_CB_ML2_LEVEL		= 128 	// Zone 3 Mic/Line 2 Mix Level
POBJ_Z3_CB_ML3_LEVEL		= 129	// Zone 3 Mic/Line 3 Mix Level
POBJ_Z3_CB_ML4_LEVEL		= 130	// Zone 3 Mic/Line 4 Mix Level
POBJ_Z3_CB_BGM_MUTEX		= 131 	// Zone 3 BGM Select & Level
POBJ_Z3_CB_MASTER_LEVEL		= 132	// Zone 3 Master Mix Level
POBJ_Z3_CB_PAGING_LEVEL		= 133	// Zone 3 Paging Mix Level

POBJ_Z4_CB_ML1_LEVEL		= 150	// Zone 4 Mic/Line 1 Mix Level
POBJ_Z4_CB_ML2_LEVEL		= 151 	// Zone 4 Mic/Line 2 Mix Level
POBJ_Z4_CB_ML3_LEVEL		= 152	// Zone 4 Mic/Line 3 Mix Level
POBJ_Z4_CB_ML4_LEVEL		= 153	// Zone 4 Mic/Line 4 Mix Level
POBJ_Z4_CB_BGM_MUTEX		= 154	// Zone 4 BGM Select & Level
POBJ_Z4_CB_MASTER_LEVEL		= 155	// Zone 4 Master Mix Level
POBJ_Z4_CB_PAGING_LEVEL		= 156	// Zone 4 Paging Mix Level

POBJ_Z5_CB_ML1_LEVEL		= 173 	// Zone 5 Mic/Line 1 Mix Level
POBJ_Z5_CB_ML2_LEVEL		= 174	// Zone 5 Mic/Line 2 Mix Level
POBJ_Z5_CB_ML3_LEVEL		= 175	// Zone 5 Mic/Line 3 Mix Level
POBJ_Z5_CB_ML4_LEVEL		= 176	// Zone 5 Mic/Line 4 Mix Level
POBJ_Z5_CB_BGM_MUTEX		= 177	// Zone 5 BGM Select & Level
POBJ_Z5_CB_MASTER_LEVEL		= 178	// Zone 5 Master Mix Level
POBJ_Z5_CB_PAGING_LEVEL		= 179	// Zone 5 Paging Mix Level

POBJ_Z6_CB_ML1_LEVEL		= 196	// Zone 6 Mic/Line 1 Mix Level
POBJ_Z6_CB_ML2_LEVEL		= 197	// Zone 6 Mic/Line 2 Mix Level
POBJ_Z6_CB_ML3_LEVEL		= 198	// Zone 6 Mic/Line 3 Mix Level
POBJ_Z6_CB_ML4_LEVEL		= 199	// Zone 6 Mic/Line 4 Mix Level
POBJ_Z6_CB_BGM_MUTEX		= 200	// Zone 6 BGM Select & Level
POBJ_Z6_CB_MASTER_LEVEL		= 201	// Zone 6 Master Mix Level
POBJ_Z6_CB_PAGING_LEVEL		= 202	// Zone 6 Paging Mix Level

POBJ_Z7_CB_ML1_LEVEL		= 219	// Zone 7 Mic/Line 1 Mix Level
POBJ_Z7_CB_ML2_LEVEL		= 220	// Zone 7 Mic/Line 2 Mix Level
POBJ_Z7_CB_ML3_LEVEL		= 221	// Zone 7 Mic/Line 3 Mix Level
POBJ_Z7_CB_ML4_LEVEL		= 222	// Zone 7 Mic/Line 4 Mix Level
POBJ_Z7_CB_BGM_MUTEX		= 223	// Zone 7 BGM Select & Level
POBJ_Z7_CB_MASTER_LEVEL		= 224	// Zone 7 Master Mix Level
POBJ_Z7_CB_PAGING_LEVEL		= 225	// Zone 7 Paging Mix Level

POBJ_Z8_CB_ML1_LEVEL		= 242 	// Zone 8 Mic/Line 1 Mix Level
POBJ_Z8_CB_ML2_LEVEL		= 243	// Zone 8 Mic/Line 2 Mix Level
POBJ_Z8_CB_ML3_LEVEL		= 244	// Zone 8 Mic/Line 3 Mix Level
POBJ_Z8_CB_ML4_LEVEL		= 245	// Zone 8 Mic/Line 4 Mix Level
POBJ_Z8_CB_BGM_MUTEX		= 246	// Zone 8 BGM Select & Level
POBJ_Z8_CB_MASTER_LEVEL		= 247	// Zone 8 Master Mix Level
POBJ_Z8_CB_PAGING_LEVEL		= 248	// Zone 8 Paging Mix Level

(* AMP COMMANDS *)
acPOWER				= 1	// Mixer On / Standby
acCAN_MUTE			= 2	// Can mute Mixer
acMUTE				= 3	// Mixer All Mute
acPING				= 4	// Ping Mixer
acSYNC				= 5	// Sync to Mixer
acPASS				= 6	// Get Mixer's password
acPRESET			= 7	// Recall Preset

acZ1MIC1			= 11	// Zone 1 Mic/Line 1 Mix Level
acZ1MIC2			= 12	// Zone 1 Mic/Line 2 Mix Level
acZ1MIC3			= 13	// Zone 1 Mic/Line 3 Mix Level
acZ1MIC4			= 14	// Zone 1 Mic/Line 4 Mix Level
acZ1BGM				= 15	// Zone 1 BGM Select & Mix Level
acZ1PAGING			= 16	// Zone 1 Paging Mix Level
acZ1				= 17	// Zone 1 Master Mix Level

acZ2MIC1			= 21	// Zone 2 Mic/Line 1 Mix Level
acZ2MIC2			= 22	// Zone 2 Mic/Line 2 Mix Level
acZ2MIC3			= 23	// Zone 2 Mic/Line 3 Mix Level
acZ2MIC4			= 24	// Zone 2 Mic/Line 4 Mix Level
acZ2BGM				= 25	// Zone 2 BGM Select & Mix Level
acZ2PAGING			= 26	// Zone 2 Paging Mix Level
acZ2				= 27	// Zone 2 Master Mix Level

acZ3MIC1			= 31	// Zone 3 Mic/Line 1 Mix L
acZ3MIC1			= 31	// Zone 3 Mic/Line 1 Mix Level
acZ3MIC2			= 32	// Zone 3 Mic/Line 2 Mix Level
acZ3MIC3			= 33	// Zone 3 Mic/Line 3 Mix Level
acZ3MIC4			= 34	// Zone 3 Mic/Line 4 Mix Level
acZ3BGM				= 35	// Zone 3 BGM Select & Mix Level
acZ3PAGING			= 36	// Zone 3 Paging Mix Level
acZ3				= 37	// Zone 3 Master Mix Level

acZ4MIC1			= 41	// Zone 4 Mic/Line 1 Mix Level
acZ4MIC2			= 42	// Zone 4 Mic/Line 2 Mix Level
acZ4MIC3			= 43	// Zone 4 Mic/Line 3 Mix Level
acZ4MIC4			= 44	// Zone 4 Mic/Line 4 Mix Level
acZ4BGM				= 45	// Zone 4 BGM Select & Mix Level
acZ4PAGING			= 46	// Zone 4 Paging Mix Level
acZ4				= 47	// Zone 4 Master Mix Level

acZ5MIC1			= 51	// Zone 5 Mic/Line 1 Mix Level
acZ5MIC2			= 52	// Zone 5 Mic/Line 2 Mix Level
acZ5MIC3			= 53	// Zone 5 Mic/Line 3 Mix Level
acZ5MIC4			= 54	// Zone 5 Mic/Line 4 Mix Level
acZ5BGM				= 55	// Zone 5 BGM Select & Mix Level
acZ5PAGING			= 56	// Zone 5 Paging Mix Level
acZ5				= 57	// Zone 5 Master Mix Level

acZ6MIC1			= 61	// Zone 6 Mic/Line 1 Mix Level
acZ6MIC2			= 62	// Zone 6 Mic/Line 2 Mix Level
acZ6MIC3			= 63	// Zone 6 Mic/Line 3 Mix Level
acZ6MIC4			= 64	// Zone 6 Mic/Line 4 Mix Level
acZ6BGM				= 65	// Zone 6 BGM Select & Mix Level
acZ6PAGING			= 66	// Zone 6 Paging Mix Level
acZ6				= 67	// Zone 6 Master Mix Level

acZ7MIC1			= 71	// Zone 7 Mic/Line 1 Mix Level
acZ7MIC2			= 72	// Zone 7 Mic/Line 2 Mix Level
acZ7MIC3			= 73	// Zone 7 Mic/Line 3 Mix Level
acZ7MIC4			= 74	// Zone 7 Mic/Line 4 Mix Level
acZ7BGM				= 75	// Zone 7 BGM Select & Mix Level
acZ7PAGING			= 76	// Zone 7 Paging Mix Level
acZ7				= 77	// Zone 7 Master Mix Level

acZ8MIC1			= 81	// Zone 8 Mic/Line 1 Mix Level
acZ8MIC2			= 82	// Zone 8 Mic/Line 2 Mix Level
acZ8MIC3			= 83	// Zone 8 Mic/Line 3 Mix Level
acZ8MIC4			= 84	// Zone 8 Mic/Line 4 Mix Level
acZ8BGM				= 85	// Zone 8 BGM Select & Mix Level
acZ8PAGING			= 86	// Zone 8 Paging Mix Level
acZ8				= 87	// Zone 8 Master Mix Level

(* TIME LINES *)
TL_TICK				= 1	// 100MS TICK
(***********************************************************)
(*              DATA TYPE DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_TYPE

STRUCTURE _MIXER
{
    INTEGER     STATUS
    INTEGER     POLL
    INTEGER     TIMEOUT
    INTEGER 	POWERED
    INTEGER 	GLOBAL_MUTED	// GLOBAL MUTE
    INTEGER	APP_STATE
    INTEGER	FORCED_STANDBY
    INTEGER	FORCED_STANDBY_ALLOWED
    INTEGER 	MIC_LEVEL[32]
    INTEGER 	MIC_MUTED[32]
    
    INTEGER 	BGM_LEVEL[8]
    INTEGER 	BGM_MUTED[8]
    INTEGER 	BGM_SELECT[8]
    
    INTEGER 	PAGING_LEVEL[8]
    INTEGER 	PAGING_MUTED[8]
    INTEGER 	MASTER_LEVEL[8]
    INTEGER 	MASTER_MUTED[8]
    
    CHAR	NAME[81]
    CHAR	MIC_NAME[4][31]
    CHAR	BGM_NAME[3][31]
    CHAR	ZONE_NAME[8][31]
    CHAR	PRESET_NAME[5][31]
    INTEGER	PRESET_VALID[5]
}

STRUCTURE _QUEUE	// QUEUE USED TO REGULATE LEVEL CHANGES
{
    INTEGER 	ID[QUEUE_SIZE]
    INTEGER 	PARAM[QUEUE_SIZE]
    INTEGER	IPTR, OPTR
    INTEGER 	COUNT
    INTEGER 	FULL
    INTEGER 	EMPTY
}

(***********************************************************)
(*               VARIABLE DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_VARIABLE

_MIXER		MIXER
_QUEUE		QUEUE
INTEGER		NO_ENTRIES
CHAR		ENTRY[MAX_ENTRIES][MAX_ENTRY_SIZE]
INTEGER		SEQ_NO
LONG		TL_TICK_COUNT[] = { 100 }

INTEGER		POLL_TIME = 60	// DEFAULT IS 6 SECONDS
INTEGER		PING_TIME = 120	// DEFAULT IS 12 SECONDS
INTEGER		RX_NO
CHAR		RX_CMD[4]
CHAR		RX_DATA[512]

(***********************************************************)
(*               LATCHING DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_LATCHING

(***********************************************************)
(*       MUTUALLY EXCLUSIVE DEFINITIONS GO BELOW           *)
(***********************************************************)
DEFINE_MUTUALLY_EXCLUSIVE

(***********************************************************)
(*        SUBROUTINE/FUNCTION DEFINITIONS GO BELOW         *)
(***********************************************************)
DEFINE_FUNCTION CHAR[255] DISPLAY_STRING (CHAR S[])
{
    CHAR RES[255]
    INTEGER I
 
    RES = ''
    FOR (I = 1; I <= LENGTH_STRING (S); I ++)
    {
	IF (S[I] >= ' ' && S[I] <= '~')
	    RES = "RES, S[I]"
	ELSE
	    RES = "RES, '<', ITOA (S[I]), '>'"
    }
  	RETURN RES
}

DEFINE_FUNCTION CHAR[255] HEX_STRING (S[])
{
    INTEGER X
    CHAR RES[255]
  
    RES = ''
    FOR (X = 1; X <= LENGTH_STRING (S); X ++)
	RES = "RES, ' ', FORMAT ('%.2X', S[X])"
    RETURN RES
}  

DEFINE_FUNCTION TERMINAL (CHAR S[])
{
// NON DEBUG VERSION
}

DEFINE_FUNCTION CHAR[2] WORD (INTEGER W)
{
    RETURN "W / $100, W % $100"
}

DEFINE_FUNCTION INTEGER PRESENT (INTEGER ID_, INTEGER PARAM_)
{
    INTEGER I, RES
    
    RES = 0
    FOR (I = 1; I <= QUEUE_SIZE; I ++)
	IF (QUEUE.ID[I] = ID_ && (QUEUE.PARAM[I] = PARAM_ || PARAM_ = 0))
	    RES ++
    RETURN RES
}

DEFINE_FUNCTION UPDATE_NAMES ()
{
    INTEGER I
    
    SEND_STRING VD_MIXER, "'NAME:', MIXER.NAME"
    FOR (I = 1; I <= 4; I ++)
	SEND_STRING VD_MIXER, "'MIC_NAME:', ITOA (I), ':', MIXER.MIC_NAME[I]"
    FOR (I = 1; I <= 3; I ++)
	SEND_STRING VD_MIXER, "'BGM_NAME:', ITOA (I), ':', MIXER.BGM_NAME[I]"
    FOR (I = 1; I <= 8; I ++)
	SEND_STRING VD_MIXER, "'ZONE_NAME:', ITOA (I), ':', MIXER.ZONE_NAME[I]"
}

DEFINE_FUNCTION UPDATE_PRESETS ()
{
    INTEGER I
    
    FOR (I = 1; I <= 5; I ++)
	SEND_STRING VD_MIXER, "'PRESET:', ITOA (I), ':', ITOA (MIXER.PRESET_VALID[I]),
			    ':', MIXER.PRESET_NAME[I]"
}

DEFINE_FUNCTION UPDATE_STATUS ()
{
//    SEND_STRING VD_MIXER, "'POWER:', ITOA (MIXER.POWERED)"
    SEND_STRING VD_MIXER, "'MUTE:', ITOA (MIXER.GLOBAL_MUTED)"
    SEND_STRING VD_MIXER, "'STATUS:', ITOA (MIXER.APP_STATE)"
    SEND_STRING VD_MIXER, "'ONLINE:', ITOA (MIXER.STATUS = lsFOUND)"
}

DEFINE_FUNCTION UPDATE_LEVELS (INTEGER ZONE_)
{
    INTEGER I, J, X
    
    IF (ZONE_ = 0)	// ALL ZONES
    {
	FOR (I = 1; I <= 8; I ++)	// ZONES
	{
	    FOR (J = 1; J <= 4; J ++)	// MIC/LINES
	    {
		X = ((I - 1) * 8) + J 
		SEND_STRING VD_MIXER, "'MIC:', ITOA (J), ':', ITOA (I), ':', ITOA (MIXER.MIC_LEVEL[X]), ':', ITOA (MIXER.MIC_MUTED[X])"
	    }
	    SEND_STRING VD_MIXER, "'BGM:', ITOA (I), ':', ITOA (MIXER.BGM_LEVEL[I]), ':', ITOA (MIXER.BGM_MUTED[I]), ':', ITOA (MIXER.BGM_SELECT[I])"
	    SEND_STRING VD_MIXER, "'MASTER:', ITOA (I), ':', ITOA (MIXER.MASTER_LEVEL[I]), ':', ITOA (MIXER.MASTER_MUTED[I])"
	    SEND_STRING VD_MIXER, "'PAGING:', ITOA (I), ':', ITOA (MIXER.PAGING_LEVEL[I]), ':', ITOA (MIXER.PAGING_MUTED[I])"
	}
    }
    ELSE
    {
	FOR (J = 1; J <= 4; J ++)	// MIC/LINES
	{
	    X = ((ZONE_ - 1) * 8) + J 
	    SEND_STRING VD_MIXER, "'MIC:', ITOA (J), ':', ITOA (ZONE_), ':', ITOA (MIXER.MIC_LEVEL[X]), ':', ITOA (MIXER.MIC_MUTED[X])"
	}
	SEND_STRING VD_MIXER, "'BGM:', ITOA (ZONE_), ':', ITOA (MIXER.BGM_LEVEL[ZONE_]), ':', ITOA (MIXER.BGM_MUTED[ZONE_]), ':', ITOA (MIXER.BGM_SELECT[ZONE_])"
	SEND_STRING VD_MIXER, "'MASTER:', ITOA (ZONE_), ':', ITOA (MIXER.MASTER_LEVEL[ZONE_]), ':', ITOA (MIXER.MASTER_MUTED[ZONE_])"
	SEND_STRING VD_MIXER, "'PAGING:', ITOA (ZONE_), ':', ITOA (MIXER.PAGING_LEVEL[ZONE_]), ':', ITOA (MIXER.PAGING_MUTED[ZONE_])"
    }
}

DEFINE_FUNCTION ADD (INTEGER ID_, INTEGER PARAM_)
{
    IF (!QUEUE.FULL)
    {       
	IF (QUEUE.IPTR = QUEUE_SIZE)
	    QUEUE.IPTR = 1;
    	ELSE
	    QUEUE.IPTR ++
	QUEUE.ID[QUEUE.IPTR] = ID_
    	QUEUE.PARAM[QUEUE.IPTR] = PARAM_
    	QUEUE.EMPTY = 0;
    	IF (QUEUE.IPTR = QUEUE_SIZE)
	    QUEUE.FULL = ((QUEUE.ID[1]) || (QUEUE.PARAM[1]));
    	ELSE
	    QUEUE.FULL = ((QUEUE.ID[QUEUE.IPTR + 1]) || 
			  (QUEUE.PARAM[QUEUE.IPTR + 1]));  
    } 
}

DEFINE_FUNCTION CHAR[255] WRITE_GLOBAL_OBJECT (INTEGER ID_, INTEGER COMMIT_, CHAR DATA_[])
{
    RETURN "$00, WORD (ID_), COMMIT_, DATA_"
}

DEFINE_FUNCTION CHAR[8] READ_GLOBAL_OBJECT (INTEGER ID_)
{
    RETURN "$01, WORD (ID_)"
}

DEFINE_FUNCTION CHAR[2] BOOL_BLOCK (INTEGER STATE_)
{
    IF (STATE_)
    	RETURN "$01, $3A"
    ELSE
	RETURN "$00, $64"
}

DEFINE_FUNCTION CHAR[255] WRITE_PRESET_OBJECT (INTEGER NO_, INTEGER ID_, CHAR DATA_[])
{
    RETURN "$00, NO_, WORD (ID_), $00, DATA_, $00"
}

DEFINE_FUNCTION CHAR[255] WRITE_MIXER_LEVEL (INTEGER NO_, INTEGER ID_, INTEGER LEVEL_, INTEGER MUTE_)
{
    RETURN WRITE_PRESET_OBJECT (NO_, ID_, "LEVEL_, MUTE_")
}

DEFINE_FUNCTION CHAR[255] WRITE_MIXER_MUTEX (INTEGER NO_, INTEGER ID_, INTEGER MUTEX_, INTEGER LEVEL_, INTEGER MUTE_)
{
    RETURN WRITE_PRESET_OBJECT (NO_, ID_, "LEVEL_, MUTE_, MUTEX_")
}

DEFINE_FUNCTION SEND (CHAR CMD_[], CHAR DATA_[])
{
    SEND_COMMAND VD_COMMS, "MIXER_NO, CMD_, DATA_"
    MIXER.TIMEOUT =  60	// ALLOW 6 SECONDS TO COMPLETE
}

DEFINE_FUNCTION SEND_CMD (INTEGER ID_, INTEGER PARAM_)
{
    SWITCH (ID_)
    {
	CASE acPOWER    : SEND ('GOBJ', WRITE_GLOBAL_OBJECT (GOBJ_FORCE_STANDBY, 0, BOOL_BLOCK (PARAM_)))
	CASE acMUTE     : SEND ('GOBJ', WRITE_GLOBAL_OBJECT (GOBJ_FORCE_GLOBAL_MUTE, 0, BOOL_BLOCK (PARAM_)))
	CASE acCAN_MUTE : SEND ('GOBJ', WRITE_GLOBAL_OBJECT (GOBJ_GLOBAL_MUTE_ALLOWED, 0, BOOL_BLOCK (PARAM_)))
	CASE acPING	: SEND ('PING', '')
	CASE acPASS     : SEND ('PASS', '')
	CASE acSYNC	: SEND ('SYNC', "PARAM_")	
	CASE acPRESET   : SEND ('PSET', "PARAM_, PARAM_, $00")
	
	CASE acZ1MIC1   : SEND ('POBJ', WRITE_MIXER_LEVEL (0, POBJ_Z1_CB_ML1_LEVEL, MIXER.MIC_LEVEL[1], MIXER.MIC_MUTED[1]))
	CASE acZ1MIC2   : SEND ('POBJ', WRITE_MIXER_LEVEL (0, POBJ_Z1_CB_ML2_LEVEL, MIXER.MIC_LEVEL[2], MIXER.MIC_MUTED[2]))
	CASE acZ1MIC3   : SEND ('POBJ', WRITE_MIXER_LEVEL (0, POBJ_Z1_CB_ML3_LEVEL, MIXER.MIC_LEVEL[3], MIXER.MIC_MUTED[3]))
	CASE acZ1MIC4   : SEND ('POBJ', WRITE_MIXER_LEVEL (0, POBJ_Z1_CB_ML4_LEVEL, MIXER.MIC_LEVEL[4], MIXER.MIC_MUTED[4]))
	CASE acZ1BGM    : SEND ('POBJ', WRITE_MIXER_MUTEX (0, POBJ_Z1_CB_BGM_MUTEX, MIXER.BGM_SELECT[1], MIXER.BGM_LEVEL[1], MIXER.BGM_MUTED[1]))
	CASE acZ1PAGING : SEND ('POBJ', WRITE_MIXER_LEVEL (0, POBJ_Z1_CB_PAGING_LEVEL, MIXER.PAGING_LEVEL[1], MIXER.PAGING_MUTED[1]))
	CASE acZ1       : SEND ('POBJ', WRITE_MIXER_LEVEL (0, POBJ_Z1_CB_MASTER_LEVEL, MIXER.MASTER_LEVEL[1], MIXER.MASTER_MUTED[1]))

	CASE acZ2MIC1   : SEND ('POBJ', WRITE_MIXER_LEVEL (0, POBJ_Z2_CB_ML1_LEVEL, MIXER.MIC_LEVEL[5], MIXER.MIC_MUTED[5]))
	CASE acZ2MIC2   : SEND ('POBJ', WRITE_MIXER_LEVEL (0, POBJ_Z2_CB_ML2_LEVEL, MIXER.MIC_LEVEL[6], MIXER.MIC_MUTED[6]))
	CASE acZ2MIC3   : SEND ('POBJ', WRITE_MIXER_LEVEL (0, POBJ_Z2_CB_ML3_LEVEL, MIXER.MIC_LEVEL[7], MIXER.MIC_MUTED[7]))
	CASE acZ2MIC4   : SEND ('POBJ', WRITE_MIXER_LEVEL (0, POBJ_Z2_CB_ML4_LEVEL, MIXER.MIC_LEVEL[8], MIXER.MIC_MUTED[8]))
	CASE acZ2BGM    : SEND ('POBJ', WRITE_MIXER_MUTEX (0, POBJ_Z2_CB_BGM_MUTEX, MIXER.BGM_SELECT[2], MIXER.BGM_LEVEL[2], MIXER.BGM_MUTED[2]))
	CASE acZ2PAGING : SEND ('POBJ', WRITE_MIXER_LEVEL (0, POBJ_Z2_CB_PAGING_LEVEL, MIXER.PAGING_LEVEL[2], MIXER.PAGING_MUTED[2]))
	CASE acZ2       : SEND ('POBJ', WRITE_MIXER_LEVEL (0, POBJ_Z2_CB_MASTER_LEVEL, MIXER.MASTER_LEVEL[2], MIXER.MASTER_MUTED[2]))

	CASE acZ3MIC1   : SEND ('POBJ', WRITE_MIXER_LEVEL (0, POBJ_Z3_CB_ML1_LEVEL, MIXER.MIC_LEVEL[9], MIXER.MIC_MUTED[9]))
	CASE acZ3MIC2   : SEND ('POBJ', WRITE_MIXER_LEVEL (0, POBJ_Z3_CB_ML2_LEVEL, MIXER.MIC_LEVEL[10], MIXER.MIC_MUTED[10]))
	CASE acZ3MIC3   : SEND ('POBJ', WRITE_MIXER_LEVEL (0, POBJ_Z3_CB_ML3_LEVEL, MIXER.MIC_LEVEL[11], MIXER.MIC_MUTED[11]))
	CASE acZ3MIC4   : SEND ('POBJ', WRITE_MIXER_LEVEL (0, POBJ_Z3_CB_ML4_LEVEL, MIXER.MIC_LEVEL[12], MIXER.MIC_MUTED[12]))
	CASE acZ3BGM    : SEND ('POBJ', WRITE_MIXER_MUTEX (0, POBJ_Z3_CB_BGM_MUTEX, MIXER.BGM_SELECT[3], MIXER.BGM_LEVEL[3], MIXER.BGM_MUTED[3]))
	CASE acZ3PAGING : SEND ('POBJ', WRITE_MIXER_LEVEL (0, POBJ_Z3_CB_PAGING_LEVEL, MIXER.PAGING_LEVEL[3], MIXER.PAGING_MUTED[3]))
	CASE acZ3       : SEND ('POBJ', WRITE_MIXER_LEVEL (0, POBJ_Z3_CB_MASTER_LEVEL, MIXER.MASTER_LEVEL[3], MIXER.MASTER_MUTED[3]))

	CASE acZ4MIC1   : SEND ('POBJ', WRITE_MIXER_LEVEL (0, POBJ_Z4_CB_ML1_LEVEL, MIXER.MIC_LEVEL[13], MIXER.MIC_MUTED[13]))
	CASE acZ4MIC2   : SEND ('POBJ', WRITE_MIXER_LEVEL (0, POBJ_Z4_CB_ML2_LEVEL, MIXER.MIC_LEVEL[14], MIXER.MIC_MUTED[14]))
	CASE acZ4MIC3   : SEND ('POBJ', WRITE_MIXER_LEVEL (0, POBJ_Z4_CB_ML3_LEVEL, MIXER.MIC_LEVEL[15], MIXER.MIC_MUTED[15]))
	CASE acZ4MIC4   : SEND ('POBJ', WRITE_MIXER_LEVEL (0, POBJ_Z4_CB_ML4_LEVEL, MIXER.MIC_LEVEL[16], MIXER.MIC_MUTED[16]))
	CASE acZ4BGM    : SEND ('POBJ', WRITE_MIXER_MUTEX (0, POBJ_Z4_CB_BGM_MUTEX, MIXER.BGM_SELECT[4], MIXER.BGM_LEVEL[4], MIXER.BGM_MUTED[4]))
	CASE acZ4PAGING : SEND ('POBJ', WRITE_MIXER_LEVEL (0, POBJ_Z4_CB_PAGING_LEVEL, MIXER.PAGING_LEVEL[4], MIXER.PAGING_MUTED[4]))
	CASE acZ4       : SEND ('POBJ', WRITE_MIXER_LEVEL (0, POBJ_Z4_CB_MASTER_LEVEL, MIXER.MASTER_LEVEL[4], MIXER.MASTER_MUTED[4]))

	CASE acZ5MIC1   : SEND ('POBJ', WRITE_MIXER_LEVEL (0, POBJ_Z5_CB_ML1_LEVEL, MIXER.MIC_LEVEL[17], MIXER.MIC_MUTED[17]))
	CASE acZ5MIC2   : SEND ('POBJ', WRITE_MIXER_LEVEL (0, POBJ_Z5_CB_ML2_LEVEL, MIXER.MIC_LEVEL[18], MIXER.MIC_MUTED[18]))
	CASE acZ5MIC3   : SEND ('POBJ', WRITE_MIXER_LEVEL (0, POBJ_Z5_CB_ML3_LEVEL, MIXER.MIC_LEVEL[19], MIXER.MIC_MUTED[19]))
	CASE acZ5MIC4   : SEND ('POBJ', WRITE_MIXER_LEVEL (0, POBJ_Z5_CB_ML4_LEVEL, MIXER.MIC_LEVEL[20], MIXER.MIC_MUTED[20]))
	CASE acZ5BGM    : SEND ('POBJ', WRITE_MIXER_MUTEX (0, POBJ_Z5_CB_BGM_MUTEX, MIXER.BGM_SELECT[5], MIXER.BGM_LEVEL[5], MIXER.BGM_MUTED[5]))
	CASE acZ5PAGING : SEND ('POBJ', WRITE_MIXER_LEVEL (0, POBJ_Z5_CB_PAGING_LEVEL, MIXER.PAGING_LEVEL[5], MIXER.PAGING_MUTED[5]))
	CASE acZ5       : SEND ('POBJ', WRITE_MIXER_LEVEL (0, POBJ_Z5_CB_MASTER_LEVEL, MIXER.MASTER_LEVEL[5], MIXER.MASTER_MUTED[5]))

	CASE acZ6MIC1   : SEND ('POBJ', WRITE_MIXER_LEVEL (0, POBJ_Z6_CB_ML1_LEVEL, MIXER.MIC_LEVEL[21], MIXER.MIC_MUTED[21]))
	CASE acZ6MIC2   : SEND ('POBJ', WRITE_MIXER_LEVEL (0, POBJ_Z6_CB_ML2_LEVEL, MIXER.MIC_LEVEL[22], MIXER.MIC_MUTED[22]))
	CASE acZ6MIC3   : SEND ('POBJ', WRITE_MIXER_LEVEL (0, POBJ_Z6_CB_ML3_LEVEL, MIXER.MIC_LEVEL[23], MIXER.MIC_MUTED[23]))
	CASE acZ6MIC4   : SEND ('POBJ', WRITE_MIXER_LEVEL (0, POBJ_Z6_CB_ML4_LEVEL, MIXER.MIC_LEVEL[24], MIXER.MIC_MUTED[24]))
	CASE acZ6BGM    : SEND ('POBJ', WRITE_MIXER_MUTEX (0, POBJ_Z6_CB_BGM_MUTEX, MIXER.BGM_SELECT[6], MIXER.BGM_LEVEL[6], MIXER.BGM_MUTED[6]))
	CASE acZ6PAGING : SEND ('POBJ', WRITE_MIXER_LEVEL (0, POBJ_Z6_CB_PAGING_LEVEL, MIXER.PAGING_LEVEL[6], MIXER.PAGING_MUTED[6]))
	CASE acZ6       : SEND ('POBJ', WRITE_MIXER_LEVEL (0, POBJ_Z6_CB_MASTER_LEVEL, MIXER.MASTER_LEVEL[6], MIXER.MASTER_MUTED[6]))

	CASE acZ7MIC1   : SEND ('POBJ', WRITE_MIXER_LEVEL (0, POBJ_Z7_CB_ML1_LEVEL, MIXER.MIC_LEVEL[25], MIXER.MIC_MUTED[25]))
	CASE acZ7MIC2   : SEND ('POBJ', WRITE_MIXER_LEVEL (0, POBJ_Z7_CB_ML2_LEVEL, MIXER.MIC_LEVEL[26], MIXER.MIC_MUTED[26]))
	CASE acZ7MIC3   : SEND ('POBJ', WRITE_MIXER_LEVEL (0, POBJ_Z7_CB_ML3_LEVEL, MIXER.MIC_LEVEL[27], MIXER.MIC_MUTED[27]))
	CASE acZ7MIC4   : SEND ('POBJ', WRITE_MIXER_LEVEL (0, POBJ_Z7_CB_ML4_LEVEL, MIXER.MIC_LEVEL[28], MIXER.MIC_MUTED[28]))
	CASE acZ7BGM    : SEND ('POBJ', WRITE_MIXER_MUTEX (0, POBJ_Z7_CB_BGM_MUTEX, MIXER.BGM_SELECT[7], MIXER.BGM_LEVEL[7], MIXER.BGM_MUTED[7]))
	CASE acZ7PAGING : SEND ('POBJ', WRITE_MIXER_LEVEL (0, POBJ_Z7_CB_PAGING_LEVEL, MIXER.PAGING_LEVEL[7], MIXER.PAGING_MUTED[7]))
	CASE acZ7       : SEND ('POBJ', WRITE_MIXER_LEVEL (0, POBJ_Z7_CB_MASTER_LEVEL, MIXER.MASTER_LEVEL[7], MIXER.MASTER_MUTED[7]))

	CASE acZ8MIC1   : SEND ('POBJ', WRITE_MIXER_LEVEL (0, POBJ_Z8_CB_ML1_LEVEL, MIXER.MIC_LEVEL[29], MIXER.MIC_MUTED[29]))
	CASE acZ8MIC2   : SEND ('POBJ', WRITE_MIXER_LEVEL (0, POBJ_Z8_CB_ML2_LEVEL, MIXER.MIC_LEVEL[30], MIXER.MIC_MUTED[30]))
	CASE acZ8MIC3   : SEND ('POBJ', WRITE_MIXER_LEVEL (0, POBJ_Z8_CB_ML3_LEVEL, MIXER.MIC_LEVEL[31], MIXER.MIC_MUTED[31]))
	CASE acZ8MIC4   : SEND ('POBJ', WRITE_MIXER_LEVEL (0, POBJ_Z8_CB_ML4_LEVEL, MIXER.MIC_LEVEL[32], MIXER.MIC_MUTED[32]))
	CASE acZ8BGM    : SEND ('POBJ', WRITE_MIXER_MUTEX (0, POBJ_Z8_CB_BGM_MUTEX, MIXER.BGM_SELECT[8], MIXER.BGM_LEVEL[8], MIXER.BGM_MUTED[8]))
	CASE acZ8PAGING : SEND ('POBJ', WRITE_MIXER_LEVEL (0, POBJ_Z8_CB_PAGING_LEVEL, MIXER.PAGING_LEVEL[8], MIXER.PAGING_MUTED[8]))
	CASE acZ8       : SEND ('POBJ', WRITE_MIXER_LEVEL (0, POBJ_Z8_CB_MASTER_LEVEL, MIXER.MASTER_LEVEL[8], MIXER.MASTER_MUTED[8]))
    }
}

DEFINE_FUNCTION EXEC ()
{
    INTEGER CHK, X
    INTEGER ID_, PARAM_
    
    IF (!QUEUE.EMPTY)
    {
	IF (QUEUE.OPTR = QUEUE_SIZE)
	    QUEUE.OPTR = 1
	ELSE
	    QUEUE.OPTR ++
	ID_ = QUEUE.ID[QUEUE.OPTR]
	PARAM_ = QUEUE.PARAM[QUEUE.OPTR]
	QUEUE.ID[QUEUE.OPTR] = 0
	QUEUE.PARAM[QUEUE.OPTR] = 0
	QUEUE.FULL = 0
	QUEUE.EMPTY = 1
	SEND_CMD (ID_, PARAM_)
	QUEUE.COUNT = 1
	FOR (CHK = 1; CHK <= QUEUE_SIZE; CHK ++)
      	    IF (QUEUE.ID[CHK]) QUEUE.EMPTY = 0
    }
}       

DEFINE_FUNCTION DECODE_DATA ()
{
    INTEGER I, J, X, Y, LEN
    INTEGER L, M, SEL		// LEVEL, MUTE, SEL
    CHAR S[255]
    LONG RX_ERR_CODE

    MIXER.TIMEOUT = 0
    LEN = LENGTH_STRING (RX_DATA)
    TERMINAL ("'RX ', ITOA (MIXER_NO), ' CMD ', RX_CMD, ' DATA ', ITOA (LEN)")
    IF (RX_CMD = 'WHAT'  && LEN = 138)		// RESPONSE TO PING COMMAND
    {
    	S = MID_STRING (RX_DATA, 58, 81)
    	X = FIND_STRING (S, "$00", 1)
	IF (X) S = LEFT_STRING (S, X - 1)
	IF (S <> MIXER.NAME)
	{
	    MIXER.NAME = S
	    SEND_STRING VD_MIXER, "'NAME:', MIXER.NAME"
	}
	IF (MIXER.STATUS = lsLOOKING)
	{
	    MIXER.STATUS = lsFOUND	 	// ONLINE
	    SEND_STRING VD_MIXER, 'ONLINE:1'
	    [VD_MIXER, 1] = 0
	    ADD (acSYNC, 100)			// GET MIC & BGM NAMES
	    ADD (acSYNC, 101)			// GET ZONE NAMES
	    ADD (acSYNC, 102)			// GET PRESET NAMES
	    ADD (acSYNC, 103)			// GET LEVELS
	}
    } 
    ELSE IF (RX_CMD = 'NACK' && LEN = 4)
    {
	RX_ERR_CODE = RX_DATA[1] * $1000000 +
		      RX_DATA[2] * $10000 +
		      RX_DATA[3] * $100 +
		      RX_DATA[4]
	SEND_STRING VD_MIXER, "'ERR:', ITOHEX (RX_ERR_CODE)"
    }
    ELSE IF (RX_CMD = 'SYNC' && LEN > 4)
    { 
	Y = RX_DATA[1]
	IF (MIXER.APP_STATE <> RX_DATA[2])
	{
	    MIXER.APP_STATE = RX_DATA[2]
	    MIXER.POWERED = MIXER.APP_STATE <> 1
	    SEND_STRING VD_MIXER, "'STATUS:', ITOA (MIXER.APP_STATE)"
	}
	IF (Y = 100 && LEN = 226)
	{
	    FOR (I = 0; I <= 3; I ++)
	    {
		S = MID_STRING (RX_DATA, 6 + (I * 31), 31)
		X = FIND_STRING (S, "$00", 1)
		IF (X) S = LEFT_STRING (S, X - 1)
		IF (S <> MIXER.MIC_NAME[I + 1])
		{
		    MIXER.MIC_NAME[I + 1] = S
		    SEND_STRING VD_MIXER, "'MIC_NAME:', ITOA (I + 1), ':', MIXER.MIC_NAME[I + 1]"
		}
	    }
	    FOR (I = 0; I <= 2; I ++)
	    {
		S = MID_STRING (RX_DATA, 130 + (I * 31), 31)
		X = FIND_STRING (S, "$00", 1)
		IF (X) S = LEFT_STRING (S, X - 1)
		IF (S <> MIXER.BGM_NAME[I + 1])
		{
		    MIXER.BGM_NAME[I + 1] = S
		    SEND_STRING VD_MIXER, "'BGM_NAME:', ITOA (I + 1), ':', MIXER.BGM_NAME[I + 1]"
		}
	    } 
(*	    MIXER.FORCED_STANDBY = RX_DATA[253]
	    MIXER.FORCED_STANDBY_ALLOWED = RX_DATA[254] *)
	    IF (MIXER.GLOBAL_MUTED <> RX_DATA[226])
	    {
		MIXER.GLOBAL_MUTED = RX_DATA[226]
		SEND_STRING VD_MIXER, "'MUTE:', ITOA (MIXER.GLOBAL_MUTED)"
	    } 
	}
	ELSE IF (Y = 101 && LEN = 253)
	{
	    FOR (I = 0; I <= 7; I ++)
	    {
		S = MID_STRING (RX_DATA, 6 + (I * 31), 31)
		X = FIND_STRING (S, "$00", 1)
		IF (X) S = LEFT_STRING (S, X - 1)
		IF (S <> MIXER.ZONE_NAME[I + 1])
		{
		    MIXER.ZONE_NAME[I + 1] = S
		    SEND_STRING VD_MIXER, "'ZONE_NAME:', ITOA (I + 1), ':', MIXER.ZONE_NAME[I + 1]"
		}
	    }
	}
	ELSE IF (Y = 102 && LEN = 165)
	{
	    FOR (I = 0; I <= 7; I ++)
	    {
		S = MID_STRING (RX_DATA, 6 + (I * 31), 31)
		X = FIND_STRING (S, "$00", 1)
		IF (X) S = LEFT_STRING (S, X - 1)
		MIXER.PRESET_NAME[I + 1] = S
		MIXER.PRESET_VALID[I + 1] = RX_DATA[161 + I]
	    }
	    UPDATE_PRESETS ()
	}
	ELSE IF (Y = 103 && LEN = 125)
	{
	    FOR (I = 0; I <= 7; I ++)		// ZONES
	    {
		X = 6 + (I * 15)
		FOR (J = 0; J <= 3; J ++)	// MIC/LINE LEVELS
		{
		    Y = (I * 4) + J + 1
		    L = RX_DATA[X + (J * 2)]
		    M = RX_DATA[X + (J * 2) + 1]
		    IF (L <> MIXER.MIC_LEVEL[Y] || M <> MIXER.MIC_MUTED[Y])
		    {
			TERMINAL ("'Y = ', ITOA (Y)")
			MIXER.MIC_LEVEL[Y] = L
			MIXER.MIC_MUTED[Y] = M
			SEND_STRING VD_MIXER, "'MIC:', ITOA (J + 1), ':', ITOA (I + 1), ':', ITOA (L), ':', ITOA (M)"			
		    }
		}
		L = RX_DATA[X + 8]
		M = RX_DATA[X + 9]
		SEL = RX_DATA[X + 10]
		IF (L <> MIXER.BGM_LEVEL[I + 1] || M <> MIXER.BGM_MUTED[I + 1] ||
		    SEL <> MIXER.BGM_SELECT[I + 1])
		{
		    MIXER.BGM_LEVEL[I + 1] = L
		    MIXER.BGM_MUTED[I + 1] = M
		    MIXER.BGM_SELECT[I + 1] = SEL
		    SEND_STRING VD_MIXER, "'BGM:', ITOA (I + 1), ':', ITOA (L), ':', ITOA (M), ':', ITOA (SEL)"			
		}
		L = RX_DATA[X + 11]
		M = RX_DATA[X + 12]
		IF (L <> MIXER.MASTER_LEVEL[I + 1] || M <> MIXER.MASTER_MUTED[I + 1])
		{
		    MIXER.MASTER_LEVEL[I + 1] = L
		    MIXER.MASTER_MUTED[I + 1] = M
		    SEND_STRING VD_MIXER, "'MASTER:', ITOA (I + 1), ':', ITOA (L), ':', ITOA (M)"			
		}
		L = RX_DATA[X + 13]
		M = RX_DATA[X + 14]
		IF (L <> MIXER.PAGING_LEVEL[I + 1] || M <> MIXER.PAGING_MUTED[I + 1])
		{
		    MIXER.PAGING_LEVEL[I + 1] = L
		    MIXER.PAGING_MUTED[I + 1] = M
		    SEND_STRING VD_MIXER, "'PAGING:', ITOA (I + 1), ':', ITOA (L), ':', ITOA (M)"			
		}
	    }
	}
    }
}

DEFINE_FUNCTION CHAR[32] STATUS_NAME (INTEGER STATUS_)
{
    SWITCH (STATUS_)
    {
	CASE lsOFFLINE : RETURN 'OFFLINE'
	CASE lsLOOKING : RETURN 'LOOKING'
	CASE lsFOUND   : RETURN 'FOUND'
	DEFAULT        : RETURN "'UNKNOWN', ITOA (STATUS_)"
    }
}

DEFINE_FUNCTION INIT ()
{
    INTEGER I, J

    FOR (I = 1; I <= QUEUE_SIZE; I ++)
    {
	QUEUE.ID[I] = 0
	QUEUE.PARAM[I] = 0
    }
    QUEUE.COUNT = 0
    QUEUE.FULL = 0
    QUEUE.EMPTY = 1

    MIXER.NAME = ''
    MIXER.POWERED = 0
    MIXER.GLOBAL_MUTED = 0
    MIXER.APP_STATE = 0
    MIXER.STATUS = lsOFFLINE
    MIXER.POLL = 0
    MIXER.TIMEOUT = 0
    
    FOR (I = 1; I <= 32; I ++)
    {
	MIXER.MIC_LEVEL[I] = 0
	MIXER.MIC_MUTED[I] = 0
    }
    FOR (I = 1; I <= 4; I ++)
	MIXER.MIC_NAME[I] = "'Mic ', ITOA (I)"
    FOR (I = 1; I <= 3; I ++)
	MIXER.BGM_NAME[I] = "'BGM ', ITOA (I)"
    FOR (I = 1; I <= 8; I ++)
    {
	MIXER.BGM_LEVEL[I] = 0;
	MIXER.BGM_MUTED[I] = 0;
	MIXER.BGM_SELECT[I] = 0;
	MIXER.PAGING_LEVEL[I] = 0;
	MIXER.PAGING_MUTED[I] = 0;
	MIXER.MASTER_LEVEL[I] = 0;
	MIXER.MASTER_MUTED[I] = 0;
	MIXER.ZONE_NAME[I] = "'Zone ', ITOA (I)"
    }

    FOR (I = 1; I <= 5; I ++)
    {
	MIXER.PRESET_NAME[I] = ''
	MIXER.PRESET_VALID[I] = 0
    }
    NO_ENTRIES = 0
    FOR (I = 1; I <= MAX_ENTRIES; I ++)
	ENTRY[I] = ''
}

(***********************************************************)
(*                STARTUP CODE GOES BELOW                  *)
(***********************************************************)
DEFINE_START

INIT ()

(***********************************************************)
(*                THE EVENTS GO BELOW                      *)
(***********************************************************)
DEFINE_EVENT

(* VIRTUAL DEVICE *)
DATA_EVENT [VD_MIXER]
{	// COMMANDS TO AMP
    COMMAND :
    {
	INTEGER I, X, Y, Z
	
//	TERMINAL (DATA.TEXT)
	NO_ENTRIES = 0
	X = FIND_STRING (DATA.TEXT, ':', 1)
	WHILE (X)
	{
	    NO_ENTRIES ++
	    ENTRY[NO_ENTRIES] = LEFT_STRING (DATA.TEXT, X - 1)
	    GET_BUFFER_STRING (DATA.TEXT, X)
	    X = FIND_STRING (DATA.TEXT, ':', 1)
	}
	NO_ENTRIES ++
	ENTRY[NO_ENTRIES] = DATA.TEXT
	FOR (X = 1; X <= NO_ENTRIES; X ++)
	    TERMINAL ("'  ', ITOA (X), '  "', ENTRY[X], '"'")
	
	IF (NO_ENTRIES = 1)
	{
	    SWITCH (ENTRY[1])
	    {
		CASE 'REFRESH' :
		{
		    UPDATE_NAMES ()
		    UPDATE_PRESETS ()
		    UPDATE_STATUS ()
		    UPDATE_LEVELS (0)
		}
	    }
	}
	ELSE IF (NO_ENTRIES = 2)
	{
	    SWITCH (ENTRY[1])
	    {
		CASE 'POWER' :	
		{	// 2 VALUE
		    SWITCH (ENTRY[2])
		    {
			CASE '0' : MIXER.POWERED = 0
			CASE '1' : MIXER.POWERED = 1
			CASE 'T' : MIXER.POWERED = !MIXER.POWERED
		    }
		    ADD (acPOWER, !MIXER.POWERED)
		    ADD (acSYNC, 100)
		    SEND_STRING VD_MIXER, "'POWER:', ITOA (MIXER.POWERED)"
		}
		CASE 'MUTE' :
		{	// 2 VALUE
		    SWITCH (ENTRY[2])
		    {
			CASE '0' : MIXER.GLOBAL_MUTED = 0
			CASE '1' : MIXER.GLOBAL_MUTED = 1
			CASE 'T' : MIXER.GLOBAL_MUTED = !MIXER.GLOBAL_MUTED
		    }
		    ADD (acMUTE, MIXER.GLOBAL_MUTED)
		    ADD (acSYNC, 100)		// GET STATUS
		    SEND_STRING VD_MIXER, "'MUTE:', ITOA (MIXER.GLOBAL_MUTED)"
		}
		CASE 'PING_TIME' : PING_TIME = ATOI (ENTRY[2])
		CASE 'POLL_TIME' : POLL_TIME = ATOI (ENTRY[2])
		CASE 'PRESET' : 
		{
		    X = ATOI (ENTRY[2])
		    ADD (acPRESET, X)
		}
	    }
	}
	ELSE IF (NO_ENTRIES = 3)
	{
	    SWITCH (ENTRY[1])
	    {
		CASE 'BGM_LEVEL' :
		{	// 2 ZONE No, 3 LEVEL
		    X = ATOI (ENTRY[2])	// ZONE No
		    IF (X && X <= 8)
		    {
			MIXER.BGM_LEVEL[X] = ATOI (ENTRY[3])
			Z = acZ1BGM + ((X - 1) * 10) 
			IF (PRESENT (Z, 0) < 2) ADD (Z, 0)
			SEND_STRING VD_MIXER, "'BGM:', ITOA (X), ':', ITOA (MIXER.BGM_LEVEL[X]), ':', ITOA (MIXER.BGM_MUTED[X]), ':', ITOA (MIXER.BGM_SELECT[X])"
			IF (!QUEUE.COUNT && !QUEUE.EMPTY) EXEC ()
		    }
		}
		CASE 'BGM_MUTE' :
		{	// 2 ZONE No, 3 VALUE
		    X  = ATOI (ENTRY[2])
		    IF (X && X <= 8)	// ZONE No
		    {
			SWITCH (ENTRY[3])
			{
			    CASE '0' : MIXER.BGM_MUTED[X] = 0
			    CASE '1' : MIXER.BGM_MUTED[X] = 1
			    CASE 'T' : MIXER.BGM_MUTED[X] = !MIXER.BGM_MUTED[X]
			}
			Z = acZ1BGM + ((X - 1) * 10) 
			IF (PRESENT (Z, 0) < 2) ADD (Z, 0)
			SEND_STRING VD_MIXER, "'BGM:', ITOA (X), ':', ITOA (MIXER.BGM_LEVEL[X]), ':', ITOA (MIXER.BGM_MUTED[X]), ':', ITOA (MIXER.BGM_SELECT[X])"
			IF (!QUEUE.COUNT && !QUEUE.EMPTY) EXEC ()
		    }
		}
		CASE 'BGM_SELECT' :
		{
		    X  = ATOI (ENTRY[2])
		    IF (X && X <= 8)	// ZONE No
		    {
			MIXER.BGM_SELECT[X] = ATOI (ENTRY[3])
			Z = acZ1BGM + ((X - 1) * 10) 
			IF (PRESENT (Z, 0) < 2) ADD (Z, 0)
			SEND_STRING VD_MIXER, "'BGM:', ITOA (X), ':', ITOA (MIXER.BGM_LEVEL[X]), ':', ITOA (MIXER.BGM_MUTED[X]), ':', ITOA (MIXER.BGM_SELECT[X])"
			IF (!QUEUE.COUNT && !QUEUE.EMPTY) EXEC ()
		    }
		}
		CASE 'PAGING_LEVEL' :
		{
		    X = ATOI (ENTRY[2])
		    IF (X && X <= 8)	// ZONE No
		    {
			MIXER.PAGING_LEVEL[X] = ATOI (ENTRY[3])
			Z = acZ1PAGING + ((X - 1) * 10) 
			IF (PRESENT (Z, 0) < 2) ADD (Z, 0)
			SEND_STRING VD_MIXER, "'PAGING:', ITOA (X), ':', ITOA (MIXER.PAGING_LEVEL[X]), ':', ITOA (MIXER.PAGING_MUTED[X])"
			IF (!QUEUE.COUNT && !QUEUE.EMPTY) EXEC ()
		    }
		}
		CASE 'PAGING_MUTE' :
		{
		    X  = ATOI (ENTRY[2])
		    IF (X && X <= 8)	// ZONE No
		    {
			SWITCH (ENTRY[3])
			{
			    CASE '0' : MIXER.PAGING_MUTED[X] = 0
			    CASE '1' : MIXER.PAGING_MUTED[X] = 1
			    CASE 'T' : MIXER.PAGING_MUTED[X] = !MIXER.PAGING_MUTED[X]
			}
			Z = acZ1PAGING + ((X - 1) * 10) 
			IF (PRESENT (Z, 0) < 2) ADD (Z, 0)
			SEND_STRING VD_MIXER, "'PAGING:', ITOA (X), ':', ITOA (MIXER.PAGING_LEVEL[X]), ':', ITOA (MIXER.PAGING_MUTED[X])"
			IF (!QUEUE.COUNT && !QUEUE.EMPTY) EXEC ()
		    }
		}
		CASE 'MASTER_LEVEL' :
		{
		    X = ATOI (ENTRY[2])
		    IF (X && X <= 8)	// ZONE No
		    {
			MIXER.MASTER_LEVEL[X] = ATOI (ENTRY[3])
			Z = acZ1 + ((X - 1) * 10) 
			IF (PRESENT (Z, 0) < 2) ADD (Z, 0)
			SEND_STRING VD_MIXER, "'MASTER:', ITOA (X), ':', ITOA (MIXER.MASTER_LEVEL[X]), ':', ITOA (MIXER.MASTER_MUTED[X])"
			IF (!QUEUE.COUNT && !QUEUE.EMPTY) EXEC ()
		    }
		}
		CASE 'MASTER_MUTE' :
		{
		    X = ATOI (ENTRY[2])
		    IF (X && X <= 8)	// ZONE No
		    {
			SWITCH (ENTRY[3])
			{
			    CASE '0' : MIXER.MASTER_MUTED[X] = 0
			    CASE '1' : MIXER.MASTER_MUTED[X] = 1
			    CASE 'T' : MIXER.MASTER_MUTED[X] = !MIXER.MASTER_MUTED[X]
			}
			Z = acZ1 + ((X - 1) * 10) 
			IF (PRESENT (Z, 0) < 2) ADD (Z, 0)
			SEND_STRING VD_MIXER, "'MASTER:', ITOA (X), ':', ITOA (MIXER.MASTER_LEVEL[X]), ':', ITOA (MIXER.MASTER_MUTED[X])"
			IF (!QUEUE.COUNT && !QUEUE.EMPTY) EXEC ()
		    }
		}
	    } 
	}
	ELSE IF (NO_ENTRIES = 4)
	{
	    SWITCH (ENTRY[1])
	    {
		CASE 'MIC_LEVEL' :
		{
		    X = ATOI (ENTRY[2])		// MIC No
		    Y = ATOI (ENTRY[3])		// ZONE No
		    IF (X && X <= 4 && Y && Y <= 8)
		    {
			I = (Y - 1) * 4 + X
			Z = acZ1MIC1 + (X - 1) + ((Y - 1) * 10)  // COMMAND ID
			MIXER.MIC_LEVEL[I] = ATOI (ENTRY[4])
			IF (PRESENT (Z, 0) < 2) ADD (Z, 0)
			SEND_STRING VD_MIXER, "'MIC:', ITOA (X), ':', ITOA (Y), ':', ITOA (MIXER.MIC_LEVEL[I]), ':', ITOA (MIXER.MIC_MUTED[I])"
			IF (!QUEUE.COUNT && !QUEUE.EMPTY) EXEC ()
		    }
		}
		CASE 'MIC_MUTE' :
		{
		    X = ATOI (ENTRY[2])		// MIC No
		    Y = ATOI (ENTRY[3])		// ZONE No
		    IF (X && X <= 4 && Y && Y <= 8)
		    {
			I = (Y - 1) * 4 + X
			Z = acZ1MIC1 + (X - 1) + ((Y - 1) * 10)  // COMMAND ID
			SWITCH (ENTRY[4])
			{
			    CASE '0' : MIXER.MIC_MUTED[I] = 0
			    CASE '1' : MIXER.MIC_MUTED[I] = 1
			    CASE 'T' : MIXER.MIC_MUTED[I] = !MIXER.MIC_MUTED[I]
			}
			IF (PRESENT (Z, 0) < 2) ADD (Z, 0)
			SEND_STRING VD_MIXER, "'MIC:', ITOA (X), ':', ITOA (Y), ':', ITOA (MIXER.MIC_LEVEL[I]), ':', ITOA (MIXER.MIC_MUTED[I])"
			IF (!QUEUE.COUNT && !QUEUE.EMPTY) EXEC ()
		    }
		}
	    } 
	} 
    }
}

BUTTON_EVENT [VD_MIXER, 0]
{	// DIGITAL COMMANDS TO AMP
    PUSH :
    {
	SWITCH (BUTTON.INPUT.CHANNEL)
	{
	    CASE 1 : ADD (acPING, 0)
	    
	    CASE 2 : ADD (acSYNC, 100);
	    CASE 3 : ADD (acSYNC, 101);
	    CASE 4 : ADD (acSYNC, 102);
	    CASE 5 : ADD (acSYNC, 2)
	    CASE 6 : ADD (acSYNC, 6)
		
	    CASE 31 : TERMINAL ("ITOA (MIXER_NO), ' STATUS ', STATUS_NAME (MIXER.STATUS)")
	    CASE 32 : SEND_COMMAND VD_COMMS, "MIXER_NO, '@MIX', MIXER_ADDR"
	
	}
    }
}

// COMMS VIRTUAL DEVICE
DATA_EVENT [VD_COMMS]
{
    ONLINE :	// REGISTER AMPLIFIER WITH COMMS AND COMMENCE POLLING
    {
	SEND_COMMAND VD_COMMS, "MIXER_NO, '@MIX', MIXER_ADDR"
	SEND_STRING VD_MIXER, 'ONLINE:0'
	MIXER.STATUS = lsLOOKING
	MIXER.POLL = RANDOM_NUMBER (30) + 100
	TIMELINE_CREATE (TL_TICK, TL_TICK_COUNT, 1, TIMELINE_ABSOLUTE, TIMELINE_REPEAT)
    }
    STRING : 	// RESPONSE FROM DEVICE
    {
	IF (LENGTH_STRING (DATA.TEXT) >= 5)
	{
	    RX_NO = GET_BUFFER_CHAR (DATA.TEXT)
	    IF (RX_NO = MIXER_NO)
	    {
		RX_CMD = GET_BUFFER_STRING (DATA.TEXT, 4)
		RX_DATA = DATA.TEXT
		DECODE_DATA ()
	    }
	}
    }
}

TIMELINE_EVENT [TL_TICK]
{
    IF (QUEUE.COUNT) QUEUE.COUNT --
    IF (!QUEUE.COUNT && !QUEUE.EMPTY) EXEC ()
    IF (MIXER.POLL)
    {
	MIXER.POLL --
	IF (!MIXER.POLL)
	{
	    SWITCH (MIXER.STATUS)
	    {
		CASE lsLOOKING :
		{
		    TERMINAL ("'PINGING MIXER ', ITOA (MIXER_NO)")
		    ADD (acPING, 0)
		    MIXER.POLL = PING_TIME
		}
		CASE lsFOUND :
		{
		    ADD (acSYNC, 100)
		    ADD (acSYNC, 103)		// UPDATE LEVELS
		    MIXER.POLL = POLL_TIME
		}
	    }
	}
    }
    IF (MIXER.TIMEOUT)
    {
	MIXER.TIMEOUT --
	IF (!MIXER.TIMEOUT)
	{
	    IF (MIXER.STATUS = lsFOUND)
	    {
	  	SEND_STRING VD_MIXER, 'ONLINE:0'
		[VD_MIXER, 1] = 0
   		MIXER.STATUS = lsLOOKING
		MIXER.POLL = PING_TIME
	    } 
	}
    }  
}

(***********************************************************)
(*            THE ACTUAL PROGRAM GOES BELOW                *)
(***********************************************************)
DEFINE_PROGRAM

IF (!QUEUE.COUNT && !QUEUE.EMPTY) EXEC ()

(***********************************************************)
(*                     END OF PROGRAM                      *)
(*        DO NOT PUT ANY CODE BELOW THIS COMMENT           *)
(***********************************************************)
